/*

  This file is part of OpenFLUID software
  Copyright(c) 2007, INRA - Montpellier SupAgro


 == GNU General Public License Usage ==

  OpenFLUID is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  OpenFLUID is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with OpenFLUID. If not, see <http://www.gnu.org/licenses/>.


 == Other Usage ==

  Other Usage means a use of OpenFLUID that is inconsistent with the GPL
  license, and requires a written agreement between You and INRA.
  Licensees for Other Usage of OpenFLUID may use this file in accordance
  with the terms contained in the written agreement between You and INRA.
  
*/


/**
 @file MarketWizardPage.hpp

 @author Manuel Chataigner <manuel.chataigner@supagro.inra.fr>
*/

#ifndef __OPENFLUID_UIMARKET_MARKETWIZARDPAGE_HPP__
#define __OPENFLUID_UIMARKET_MARKETWIZARDPAGE_HPP__


#include <QWizardPage>

#include <openfluid/dllexport.hpp>


namespace openfluid { namespace ui { namespace market {


class OPENFLUID_API MarketWizardPage : public QWizardPage
{
  Q_OBJECT;

  private:

    bool m_PackagesSelected;

    bool m_LicensesRadioAccepted;

    bool m_InstallationFinished;

    bool isSelectionPage() const
    { return nextId() == 1; }

    bool isLicensesnPage() const
    { return nextId() == 2; }

    bool isInstallPage() const
    { return nextId() == -1; }


  public:

    MarketWizardPage(QWidget *Parent = nullptr);

    virtual bool isComplete() const;

    void setPageComplete(bool Complete);
};


} } } // namespaces


#endif /* __OPENFLUID_UIMARKET_MARKETWIZARDPAGE_HPP__ */
